#include <stdint.h>
#include <cpu.h>
#include <memory.h>
#include <vga.h>
#include <debug.h>
#include <multiboot.h>
#include <interrupts.h>

struct kernel_boot_data_st kernel_boot_data;

void kmain(uint64_t multiboot_magic, void *multiboot_data)
{
    multiboot_init(multiboot_magic, P2V(multiboot_data));

    cpu_init();
    memory_init();

    vga_init();
    
    debug("Started kernel\n");
    debug_info("Kernel loaded with command line: \"%s\" by <%s>\n", kernel_boot_data.commandline, kernel_boot_data.bootloader);

    debug_info("Boot complete\n");

    PANIC("End of kernel function!");
    
    debug_info("Broke out of panic");
    for(;;);
}